;******************************************
;   
;  ATtiny26.   .. 7.03.15
;******************************************
.INCLUDE"TN26DEF.INC"
.CSEG
.ORG  0
RJMP  RESET
RETI
RETI
RETI
RETI
RJMP  TM1_OV
RETI
RETI
RETI
RETI
RETI
RETI
;******TM1_ISR*******************
TM1_OV:
IN   R2,SREG
IN   R16,TCCR1B
CPI  R16,15
BRLO END
INC  R17
CPI  R17,36
BRLO END
CLR  R17
ADD  R4,R6
ADC  R5,R10 
END:
SBIS PINA,3
RJMP LON
LOF: CBI PORTA,3
RJMP L
LON: SBI PORTA,3 
L:
OUT  TCNT1,R7
OUT  SREG,R2
RETI
;***********MACRO COMMAND*********
.MACRO READ_ADC ;MACRO ADC
LDI  R18,160
ORI  R18,@0
OUT  ADMUX,R18
NOP
SBI  ADCSRA,6
SBIS ADCSRA,4
RJMP PC-1
SBI  ADCSRA,4
IN   R@1,ADCH
.ENDM
;--------------MACRO DIV----------
.MACRO DIV_TS
CLR  R22
CLR  R23
TST  R21
BREQ M6
M0:
CPI  R20,LOW(10000)
LDI  R30,HIGH(10000)
CPC  R21,R30
BRLO M
SUBI R23,-16
SUBI R20,LOW(10000)
SBCI R21,HIGH(10000)
RJMP M0
////////////////////////////////////
M:
CPI  R20,LOW(8000)
LDI  R30,HIGH(8000)
CPC  R21,R30
BRLO M1
SBR  R23,8
SUBI R20,LOW(8000)
SBCI R21,HIGH(8000)
RJMP M3
M1:
CPI  R20,LOW(4000)
LDI  R30,HIGH(4000)
CPC  R21,R30
BRLO M2
SBR  R23,4
SUBI R20,LOW(4000)
SBCI R21,HIGH(4000)
M2:
CPI  R20,LOW(2000)
LDI  R30,HIGH(2000)
CPC  R21,R30
BRLO M3
SBR  R23,2
SUBI R20,LOW(2000)
SBCI R21,HIGH(2000)
M3:
CPI  R20,LOW(1000)
LDI  R30,HIGH(1000)
CPC  R21,R30
BRLO M4
SBR  R23,1
SUBI R20,LOW(1000)
SBCI R21,HIGH(1000)
M4:   ////////////////////////////
CPI  R20,LOW(800)
LDI  R30,HIGH(800)
CPC  R21,R30
BRLO M5
SBR  R22,128
SUBI R20,LOW(800)
SBCI R21,HIGH(800)
RJMP M7
M5:
CPI  R20,LOW(400)
LDI  R30,HIGH(400)
CPC  R21,R30
BRLO M6
SBR  R22,64
SUBI R20,LOW(400)
SBCI R21,HIGH(400)
M6:
CPI  R20,LOW(200)
CPC  R21,R10
BRLO M7
SBR  R22,32
SUBI R20,LOW(200)
SBCI R21,HIGH(200)
M7:
CPI  R20,100
BRLO M8
SBR  R22,16
SUBI R20,100
M8:   ///////////////////////////
CPI  R20,80
BRLO M9
SBR  R22,8
SUBI R20,80
RJMP M11
M9:
CPI  R20,40
BRLO M10
SBR  R22,4
SUBI R20,40
M10:
CPI  R20,20
BRLO M11
SBR  R22,2
SUBI R20,20
M11:
CPI  R20,10
BRLO M12
SBR  R22,1
SUBI R20,10
M12: 
.ENDM  ;------END MACRO DIV------- 
;--------------MACRO ZNAK--------
.MACRO ZNAK
CLR  ZH
LDI  ZL,96
ADD  ZL,R14
LD   R11,Z
OUT  PORTB,R11
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP 
CLR  ZH
LDI  ZL,112
ADD  ZL,R14
LD   R11,Z
OUT  PORTB,R11
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
.ENDM  ;END MACRO ZNAK
;-------CLEAN ZNAK--------------
.MACRO CLEAN_Z
OUT  PORTB,R10
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
.ENDM
;********END MACRO COMMAND*******
RESET:
CLI
LDI  R16,RAMEND
OUT  SP,R16
CLR  R10
LDI  R16,31
MOV  R7,R16
LDI  R16,15
MOV  R15,R16
LDI  R16,4
OUT  TIMSK,R16
LDI  R16,200
OUT  DDRA,R16
LDI  R16,56
OUT  PORTA,R16 
LDI  R16,79
OUT  DDRB,R16
OUT  PORTB,R10
LDI  R16,128
OUT  ACSR,R16
LDI  R16,133
OUT  ADCSR,R16
;RAM_WRITE***********************
LDI  R16,14
STS  96,R16
STS  112,R16
STS  116,R16
STS  119,R16
STS  120,R16
STS  121,R16
STS  97,R10
STS  108,R10 
STS  123,R10
STS  124,R10
STS  98,R15
STS  102,R15
STS  104,R15
STS  106,R15
LDI  R16,13
STS  99,R16
STS  101,R16
STS  105,R16
LDI  R16,1
STS  100,R16
LDI  R16,8
STS  103,R16
STS  122,R16
LDI  R16,6
STS  113,R16
STS  115,R16
LDI  R16,2
STS  114,R16
LDI  R16,12
STS  117,R16
STS  118,R16
LDI  R16,3
STS  107,R16

SEI
;INDICATOR INI(UNLOCK)*********************
OUT  PORTB,R15
CBI  PORTA,6
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
SBI  PORTA,6
NOP
SBI  PORTB,0
NOP
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
;----------------------------------
CLR  R4
CLR  R5
MAIN:
SBIC PINA,4
RJMP R
CLR  R4
CLR  R5
CLR  R6
CLR  R8
CLR  R17
READ_ADC 13,3
SBI  PORTA,7
CLR  R24
SUBI R24,16
BRNE PC-1
READ_ADC 14,6
LDI  R18,100
CP   R6,R18        //IF I  = Imax 
BRLO S
CBI  PORTA,7       //MOSFET OFF
SBI  PORTA,3       //LED ON
LDI  R18,11
OUT  TCCR1B,R18    //CLOCK TIMER = 3600 Hz
CLR  R4            //
CLR  R5            //
RJMP MAIN 
S:
LDI  R24,LOW(500)
LDI  R25,HIGH(500)
P:   SBIW R24,1
BRNE P
READ_ADC 0,8
LDI  R18,8
CP   R8,R18
BRSH SS
CBI  PORTA,7
SBI  PORTA,3
LDI  R18,13
OUT  TCCR1B,R18    //CLOCK TIMER1 = 900 Hz
RJMP MAIN
SS:
MOV  R12,R8
LSR  R12
LSR  R12
SUB  R8,R12        ;R8 = R8 - 25%
LDI  R18,15
OUT  TCCR1B,R18
R:
LDI  R18,100       //Imax 10,0A
READ_ADC 13,3
READ_ADC 14,6
CP   R6,R18
BRLO RR
CBI  PORTA,7       //MOSFET OFF
CLR  R4
CLR  R5
LDI  R18,11
OUT  TCCR1B,R18    //CLOCK TM1 = 3600 Hz
RJMP MAIN
RR:
LDI  R24,LOW(500)
LDI  R25,HIGH(500)
P0:  SBIW R24,1
BRNE P0
READ_ADC 0,12
IN   R18,TCCR1B
TST  R18
BREQ IND
CP   R12,R8      // IF U < U comp (Ubegin -25%)
BRSH IND
CBI  PORTA,7     //MOSFET OFF
OUT  TCCR1B,R10  //TIMER1 STOP 
SBI  PORTA,3     //LED ON
IND: 
;***********************************************
;ERROR IND
IN   R16,TCCR1B
CPI  R16,11
BRNE ERU
LDI  R23,171 ;R23 7-4 E, 3-0 r /INDEX RAM
LDI  R22,177 ;R22 7-4 r, 3-0 -1 
LDI  R20,12  ;RAM 0 INDEX - CLEAN
RJMP D
ERU:
CPI  R16,13
BRNE DV
LDI  R23,171 ;Er /INDEX RAM
LDI  R22,178 ;r2 /INDEX RAM
LDI  R20,12
RJMP D
DV:
;***********************************************
MOV  R20,R4
MOV  R21,R5      
DIV_TS           //R23 7-4 -TT; 3-0 -TU
D:               //R22 7-4-H,3-0-T; R20-U
MOV  R13,R12
SBIS PINA,5
MOV  R13,R6      //IF BUTTON IS PRESSED IN I
MOV  R18,R13
CLR  R19
CPI  R18,200
BRLO A
SUBI R18,200
SBR  R19,32
RJMP A0
A:  
CPI  R18,100
BRLO A0
SUBI R18,100
SBR  R19,16
A0:
CPI  R18,80
BRLO A1
SUBI R18,80
SBR  R19,8
RJMP A3
A1:
CPI  R18,40
BRLO A2
SUBI R18,40
SBR  R19,4
A2:
CPI  R18,20
BRLO A3
SUBI R18,20
SBR  R19,2
A3:
CPI  R18,10
BRLO LCD
SUBI R18,10
SBR  R19,1    ;R19 7-4 BIT - H
LCD:          ;R19 3-0 BIT - T; R18 - U
;******IND INI(SET ADR0)********************
OUT  PORTB,R10
CBI  PORTA,6
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
SBI  PORTA,6
NOP
NOP
NOP
;(**********CLEAR LCD*******************
LDI  R24,20
I:
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
DEC  R24
BRNE I
;--------LCD START(ADRES 0 WRITE)------
CBI  PORTA,6
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
SBI  PORTA,6
NOP
NOP
NOP
;---------TT INDEX AR -----------------
MOV  R14,R23
SWAP R14
AND  R14,R15
;-------FIRST ZNAK---------------------
TST  R14
BRNE TT
CLEAN_Z
RJMP Z2
TT:
ZNAK
NOP
Z2:
MOV  R14,R23
AND  R14,R15
;----------2 ZNAK---------------------
CLR  ZH
LDI  ZL,96
ADD  ZL,R14
LD   R11,Z
OUT  PORTB,R11
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
CLR  ZH
LDI  ZL,112
ADD  ZL,R14
LD   R11,Z
OUT  PORTB,R11
IN   R16,TCCR1B
CPI  R16,11
BREQ ER
CPI  R16,13
BREQ ER
SBI  PORTB,0  ;DEZIMAL SEGMENT
ER:
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
;--------H INDEX AR-------------------
MOV  R14,R22
SWAP R14
AND  R14,R15
;-----------3 ZNAK--------------------
ZNAK
;-------T INDEX AR--------------------
MOV  R14,R22
AND  R14,R15
;-----------4 ZNAK--------------------
ZNAK
;-------U INDEX AR--------------------
MOV  R14,R20
;-----------5 ZNAK--------------------
ZNAK
;----------6 ZNAK(CLEAN)--------------
CLEAN_Z
;----------7 ZNAK(SYMBOL U or I)------
SBIS PINA,5
RJMP Z7
SBI  PORTB,1
SBI  PORTB,2
Z7:
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,1
SBI  PORTB,2
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
;---U or I  INDEX AR-------------------
MOV  R14,R19
SWAP R14
AND  R14,R15
;------------8 ZNAK--------------------
TST  R14
BRNE HI
CLEAN_Z
RJMP Z9
HI:
ZNAK
Z9:
;-----------9 ZNAK---------------------
MOV  R14,R19
AND  R14,R15
CLR  ZH
LDI  ZL,96
ADD  ZL,R14
LD   R11,Z
OUT  PORTB,R11
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
CLR  ZH
LDI  ZL,112
ADD  ZL,R14
LD   R11,Z
OUT  PORTB,R11
SBI  PORTB,0  ;DEZIMAL SEGMENT
SBI  PORTB,6
NOP
NOP
NOP
CBI  PORTB,6
NOP
NOP
NOP
;---------10 ZNAK-------------------------
MOV  R14,R18
ZNAK
CLR  R24
CLR  R25
LDI  R18,5
PAUSE:
SBIW R24,1
BRNE PAUSE
DEC  R18
BRNE PAUSE
RJMP MAIN 

